'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 22 March 2006 at 6:56:25 pm'!
"Change Set:		02LanguageBackport
Date:			22 March 2006
Author:			Alberto Berti, Takashi Yamamiya

Backport from Squeakland.
This change set includes followed patches in Squeakland.

0484LocaleRefactoring2-tak
0497miscCharFix-tak
0498MacUnicodeIInterp
0501PercentEncodingFix
0508BOMLangEditor-yo
0509initKnownEnv-yo
0512macosxJaMarks-tetha
0513setupLanguageSpec-tak
0515AddTranslationNov30
0523stringEqual2-yo
0524fixcharConv128-255-tak
0532SuperSwikiString-KR
6592langEditorMimeExport
"!

KeyboardInputInterpreter subclass: #MacUnicodeInputInterpreter
	instanceVariableNames: 'keyValueIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-TextConversion'!

!ButtonProperties methodsFor: 'accessing' stamp: 'yo 11/30/2005 14:20'!
establishEtoyLabelWording
	"Set the label wording, unless it has already been manually edited"

	| itsName |

	self isTileScriptingElement ifFalse: [^self].
	itsName _ target externalName.
	self addTextToButton: itsName, ' ', arguments first.
	visibleMorph setBalloonText: 
		('click to run the script "{1}" in player named "{2}"' translated format: {arguments first. itsName}).
! !


!CharacterScanner methodsFor: 'scanning' stamp: 'tak 11/8/2005 11:25'!
scanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta

	| startEncoding selector |
	(sourceString isByteString) ifTrue: [^ self basicScanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta.].

	(sourceString isWideString) ifTrue: [
		startIndex > stopIndex ifTrue: [lastIndex _ stopIndex. ^ stops at: EndOfRun].
		startEncoding _  (sourceString at: startIndex) leadingChar.
		selector _ EncodedCharSet scanSelectorAt: startEncoding.
		^ self perform: selector withArguments: (Array with: startIndex with: stopIndex with: sourceString with: rightX with: stopConditions with: kernDelta).
	].
	
	^ stops at: EndOfRun
! !


!EncodedCharSet class methodsFor: 'class methods' stamp: 'tak 11/5/2005 18:14'!
charFromUnicode: unicode

	| table index |
	unicode < 128 ifTrue: [^ Character value: unicode].

	table _ self ucsTable.
	index _ table indexOf: unicode.
	index = 0 ifTrue: [
		^ nil.
	].

	^ Character leadingChar: self leadingChar code: index - 1.

! !

!EncodedCharSet class methodsFor: 'class methods' stamp: 'tak 11/8/2005 11:19'!
scanSelectorAt: encoding 
	| charset |
	charset := self charsetAt: encoding.
	^ charset
		ifNil: [LanguageEnvironment scanSelector]
		ifNotNil: [charset scanSelector]! !

!EncodedCharSet class methodsFor: 'accessing - displaying' stamp: 'tak 11/8/2005 11:26'!
scanSelector
	^ #scanMultiCharactersFrom:to:in:rightX:stopConditions:kern:! !


!HTTPDownloadRequest methodsFor: 'initialize' stamp: 'KR 9/4/2005 10:33'!
for: aUrl in: aLoader
	url _ aUrl.
	loader _ aLoader.
	semaphore _ Semaphore new.! !


!LanguageEditor methodsFor: 'gui methods' stamp: 'yo 11/29/2005 11:20'!
codeSelectedTranslationAsMimeString
	| keys code tmpStream s2 gzs cont |
	keys := selectedTranslations
				collect: [:key | self translations at: key].
	code := String
				streamContents: [:aStream | self translator fileOutOn: aStream keys: keys].

	tmpStream _ MultiByteBinaryOrTextStream on: ''.
	tmpStream converter: UTF8TextConverter new.
	translator fileOutHeaderOn: tmpStream.
	tmpStream nextPutAll: code.
	s2 _ RWBinaryOrTextStream on: ''.
	gzs := GZipWriteStream on: s2.
	tmpStream reset.
	gzs nextPutAll: (tmpStream binary contentsOfEntireFile asString) contents.
	gzs close.
	s2 reset.

	cont _ String streamContents: [:strm |
		strm nextPutAll: '"Gzip+Base64 encoded translation for;'; cr.
		strm nextPutAll: '#('.
		keys do: [:each | strm  nextPutAll: '''', each, ''' '.].
		strm nextPutAll: ')"'; cr; cr.
		strm nextPutAll: 'NaturalLanguageTranslator loadForLocaleIsoString: '.
		strm nextPut: $'.
		strm nextPutAll: translator localeID isoString.
		strm nextPut: $'.
		strm nextPutAll: ' fromGzippedMimeLiteral: '.
		strm nextPut: $'.
		strm nextPutAll: (Base64MimeConverter mimeEncode: s2) contents.
		strm nextPutAll: '''.'.
		strm cr.
	].
	
	(StringHolder new contents: cont)
		openLabel: 'exported codes in Gzip+Base64 encoding'! !

!LanguageEditor methodsFor: 'initialization - toolbar' stamp: 'AB 3/2/2006 15:55'!
createMainToolbar
	"create a toolbar for the receiver"
	| toolbar |
	toolbar := self createRow.
	""
"	toolbar
		addMorphBack: (self
				createUpdatingButtonWording: #debugWording
				action: #switchDebug
				help: 'Switch the debug flag')."
	toolbar addTransparentSpacerOfSize: 5 @ 0.
	""
	toolbar
		addMorphBack: (self
				createButtonLabel: 'new'
				action: #newTranslations
				help: 'Create translations for new language.').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'save'
				action: #saveToFile
				help: 'Save the translations to a file').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'load'
				action: #loadFromFile
				help: 'Load the translations from a file').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'merge'
				action: #mergeFromFile
				help: 'Merge the current translations with the translations in a file').
	""
	toolbar addTransparentSpacerOfSize: 5 @ 0.
	toolbar
		addMorphBack: (self
				createButtonLabel: 'apply'
				action: #applyTranslations
				help: 'Apply the translations as much as possible.').
	""
	toolbar addTransparentSpacerOfSize: 5 @ 0.
	toolbar
		addMorphBack: (self
				createButtonLabel: 'check translations'
				action: #check
				help: 'Check the translations and report the results.').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'report'
				action: #report
				help: 'Create a report.').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'gettext'
				action: #getText
				help: 'Interface with gettext.').
	""
	^ toolbar! !

!LanguageEditor methodsFor: 'initialization' stamp: 'AB 3/2/2006 16:07'!
initializeOn: aLanguage 
	"initialize the receiver on aLanguage"
	""
	selectedTranslation := 0.
	selectedUntranslated := 0.
	selectedTranslations := IdentitySet new.
	""
	translator := aLanguage.
	""
	self model: aLanguage.
	self setLabel: 'Language editor for: ' translated , self translator name.
	""
	self initializeToolbars.
	self initializePanels.
	self initializeStatusbar.
	self initializeNewerKeys.
! !


!LanguageEnvironment methodsFor: 'utilities' stamp: 'tak 11/28/2005 17:28'!
setupSqueaklandSpecifics
	"Write language specific settings here"! !


!JapaneseEnvironment methodsFor: 'utilities' stamp: 'KR 1/30/2006 22:28'!
setupSqueaklandSpecifics
	| server |
	ChangeSet current name: 'Unnamed' translated , '1'.
	ServerDirectory resetServers.
	server := SuperSwikiServer new type: #http;
				 server: 'squeakland.jp';
				 directory: '/super/SuperSwikiProj';
				 acceptsUploads: (Preferences eToyFriendly not);
				 encodingName: 'shift_jis'.
	ServerDirectory servers at: 'Squeakland.JP' put: server.
	Smalltalk garbageCollect! !


!LanguageEnvironment class methodsFor: 'private' stamp: 'yo 11/29/2005 13:33'!
initKnownEnvironments
	"LanguageEnvironment initKnownEnvironments"

	| env known id |
	known := Dictionary new.
	self allSubclassesDo: [:subClass | 
		subClass supportedLanguages do: [:language | 
			env := subClass new.
			id _ LocaleID isoString: language.
			env localeID: id.
			known at: id put: env]].
	^known! !


!Locale class methodsFor: 'accessing' stamp: 'tak 10/18/2005 22:33'!
currentPlatform: locale during: aBlock 
	"Alter current language platform during a block"
	| backupPlatform |
	backupPlatform := self currentPlatform.
	[self currentPlatform: locale.
	aBlock value]
		ensure: [self currentPlatform: backupPlatform]! !


!MacUnicodeInputInterpreter methodsFor: 'keyboard' stamp: 'tetha 11/22/2005 21:49'!
nextCharFrom: sensor firstEvt: evtBuf 
	| keyValue mark |
	keyValue := evtBuf at: self keyValueIndex.
	mark := self japaneseSpecialMark: keyValue.
	mark notNil
		ifTrue: [^ mark].
	keyValue < 256
		ifTrue: [^ (Character value: keyValue) squeakToIso].
	"Smalltalk systemLanguage charsetClass charFromUnicode: keyValue."
	^ Unicode value: keyValue! !

!MacUnicodeInputInterpreter methodsFor: 'initialization' stamp: 'ts 10/29/2005 10:22'!
initialize
	| satisfiesVersion |
	satisfiesVersion := self
				majorMinorBuildFrom: SmalltalkImage current vmVersion
				satisfies: [:major :minor :build | major >= 3
						and: [minor >= 8
								and: [build >= 7]]].
	satisfiesVersion
		ifTrue: [keyValueIndex := 6]
		ifFalse: [keyValueIndex := 3]! !

!MacUnicodeInputInterpreter methodsFor: 'accessing' stamp: 'ts 10/29/2005 10:23'!
keyValueIndex
	^ keyValueIndex! !

!MacUnicodeInputInterpreter methodsFor: 'version check' stamp: 'ts 10/29/2005 10:17'!
majorMinorBuildFrom: aString satisfies: aBlock 
	| v |
	v := aString
				ifNil: [^ false].
	v := ((v copyAfter: $])
				findTokens: $ ) last findTokens: $..
	v size = 3
		ifFalse: [^ false].
	v := v
				collect: [:s | s initialIntegerOrNil
						ifNil: [^ false]].
	^ aBlock valueWithArguments: v asArray! !

!MacUnicodeInputInterpreter methodsFor: 'conversion' stamp: 'tetha 11/22/2005 22:05'!
japaneseSpecialMark: anInteger 
	"For japanese special marks.
	This method converts 'YEN SIGN' (16rA5) to 'REVERSE SOLIDUS' (16r5C)
	and use Japanese leading characters instead of Unicode for below
	characters.
	'CENT SIGN' (16rA2)
	'POUND SIGN' (16rA3)
	'SECTION SIGN' (16rA7)
	'DIAERESIS' (16rA8)
	'NOT SIGN' (16rAC)
	'DEGREE SIGN' (16rB0)
	'PLUS-MINUS SIGN (16rB1)
	'ACUTE ACCENT' (16rB4)
	'PILCROW SIGN' (16rB6)
	'MULTIPLICATION SIGN' (16rD7)
	'DIVISION SIGN' (16rF7)
	"
	Project current localeID
			= (LocaleID isoLanguage: 'ja')
		ifTrue: [anInteger = 16rA5
				ifTrue: [^ Character value: 16r5C].
			(#(16rA2 16rA3 16rA7 16rA8 16rAC 16rB0 16rB1 16rB4 16rB6 16rD7 16rF7) includes: anInteger)
				ifTrue: [^ Character leadingChar: JapaneseEnvironment leadingChar code: anInteger]].
	^ nil! !


!MultiCharacterScanner methodsFor: 'scanning' stamp: 'tak 11/8/2005 11:25'!
scanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta

	| startEncoding selector |
	(sourceString isByteString) ifTrue: [^ self basicScanCharactersFrom: startIndex to: stopIndex in: sourceString rightX: rightX stopConditions: stops kern: kernDelta.].

	(sourceString isWideString) ifTrue: [
		startIndex > stopIndex ifTrue: [lastIndex _ stopIndex. ^ stops at: EndOfRun].
		startEncoding _  (sourceString at: startIndex) leadingChar.
		selector _ EncodedCharSet scanSelectorAt: startEncoding.
		^ self perform: selector withArguments: (Array with: startIndex with: stopIndex with: sourceString with: rightX with: stopConditions with: kernDelta).
	].
	
	^ stops at: EndOfRun
! !


!NaturalLanguageTranslator methodsFor: 'fileIn/fileOut' stamp: 'yo 11/29/2005 11:19'!
fileOutOn: aStream 
	"self current fileOutOn: Transcript. Transcript endEntry"
	self fileOutHeaderOn: aStream.
	self fileOutOn: aStream keys: nil! !

!NaturalLanguageTranslator methodsFor: 'fileIn/fileOut' stamp: 'yo 11/29/2005 11:19'!
fileOutOn: aStream keys: keys 
	"self current fileOutOn: Transcript. Transcript endEntry"
	(keys
		ifNil: [generics keys asSortedCollection])
		do: [:key | self
				nextChunkPut: (generics associationAt: key)
				on: aStream].
	keys
		ifNil: [self untranslated
				do: [:each | self nextChunkPut: each -> '' on: aStream]].
	aStream nextPut: $!!;
		 cr! !


!PasteUpMorph methodsFor: 'event handling' stamp: 'tak 11/6/2005 23:24'!
dropFiles: anEvent
	"Handle a number of dropped files from the OS.
	TODO:
		- use a more general mechanism for figuring out what to do with the file (perhaps even offering a choice from a menu)
		- remember the resource location or (when in browser) even the actual file handle
	"
	| numFiles stream handler |
	numFiles _ anEvent contents.
	1 to: numFiles do: [:i |
		stream _ FileStream requestDropStream: i.
		stream ifNotNil: [
			handler _ ExternalDropHandler lookupExternalDropHandler: stream.
			[handler ifNotNil: [handler handle: stream in: self dropEvent: anEvent]]
				ensure: [stream close]]].! !


!ProjectLauncher methodsFor: 'running' stamp: 'KR 8/30/2005 17:41'!
startUpAfterLogin
	| scriptName loader isUrl |
	self setupFlaps.
	Preferences readDocumentAtStartup ifTrue: [
		HTTPClient isRunningInBrowser ifTrue:[
			self setupFromParameters.
			scriptName _ self parameterAt: 'src'.
			CodeLoader defaultBaseURL: (self parameterAt: 'Base').
		] ifFalse:[
			scriptName _ (SmalltalkImage current getSystemAttribute: 2) ifNil:[''].
			scriptName _ scriptName convertFromSystemString.
			scriptName isEmpty ifFalse:[
				"figure out if script name is a URL by itself"
				isUrl _ (scriptName asLowercase beginsWith:'http://') or:[
						(scriptName asLowercase beginsWith:'file://') or:[
						(scriptName asLowercase beginsWith:'ftp://')]].
				isUrl ifFalse:[scriptName _ 'file:',scriptName]].
		]. ]
	ifFalse: [ scriptName := '' ].

	scriptName isEmptyOrNil
		ifTrue:[^Preferences eToyFriendly ifTrue: [self currentWorld addGlobalFlaps]].
	loader _ CodeLoader new.
	loader loadSourceFiles: (Array with: scriptName).
	(scriptName asLowercase endsWith: '.pr') 
		ifTrue:[self installProjectFrom: loader]
		ifFalse:[loader installSourceFiles].
! !


!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'tak 11/28/2005 17:25'!
setupLanguageSpecifics
	"ReleaseBuilderSqueakland new setupLanguageSpecifics"
	Locale current languageEnvironment setupSqueaklandSpecifics! !


!ScriptActivationButton methodsFor: 'label' stamp: 'yo 11/30/2005 14:14'!
establishLabelWording
	"Set the label wording, unless it has already been manually edited"

	| itsName |
	itsName _ target externalName.
	(self hasProperty: #labelManuallyEdited)
		ifFalse:
			[self label: (itsName, ' ', arguments first)].
	self setBalloonText: 
		('click to run the script "{1}" in player named "{2}"' translated format: {arguments first. itsName}).
! !


!String methodsFor: 'comparing' stamp: 'yo 12/15/2005 14:28'!
compare: string1 with: string2 collated: order

	(string1 isByteString and: [string2 isByteString]) ifTrue: [
		^ ByteString compare: string1 with: string2 collated: order
	].
     "Primitive does not fail properly right now"
      ^ String compare: string1 with: string2 collated: order

"
self assert: 'abc' = 'abc' asWideString.
self assert: 'abc' asWideString = 'abc'.
self assert: ((ByteArray with: 97 with: 0 with: 0 with: 0) asString ~= 'a000' asWideString).
self assert: ('a000' asWideString ~= (ByteArray with: 97 with: 0 with: 0 with: 0) asString).

self assert: ('abc' sameAs: 'aBc' asWideString).
self assert: ('aBc' asWideString sameAs: 'abc').
self assert: ((ByteArray with: 97 with: 0 with: 0 with: 0) asString sameAs: 'Abcd' asWideString) not.
self assert: ('a000' asWideString sameAs: (ByteArray with: 97 with: 0 with: 0 with: 0) asString) not.

"! !

!String methodsFor: 'converting' stamp: 'KR 9/22/2005 23:06'!
unescapePercents
	"decode %xx form.  This is the opposite of #encodeForHTTP"
	^ self unescapePercentsWithTextEncoding: 'utf-8'.! !

!String methodsFor: 'converting' stamp: 'KR 9/22/2005 23:07'!
unescapePercentsWithTextEncoding: encodingName
	"decode string including %XX form"
	| ans c asciiVal pos oldPos specialChars encodedStream converter |
	encodedStream _ ReadWriteStream on: String new.
	converter _ TextConverter newForEncoding: encodingName.
	ans _ WriteStream on: String new.
	oldPos _ 1.
	specialChars _ '+%' asCharacterSet.

	[pos _ self indexOfAnyOf: specialChars startingAt: oldPos. pos > 0]
	whileTrue: [
		ans nextPutAll: (self copyFrom: oldPos to: pos - 1).
		c _ self at: pos.
		(c = $% and: [pos + 2 <= self size]) 
			ifTrue: [
				encodedStream reset.
				[c = $% ] whileTrue: [
	
				asciiVal _ (self at: pos+1) asUppercase digitValue * 16 +
							(self at: pos+2) asUppercase digitValue.
	
				asciiVal > 255 ifTrue: [^self].	"not really an escaped string".
					encodedStream nextPut: (Character value: asciiVal).
	
				pos _ pos + 3.
					(pos <= self size) 
						ifTrue:  [c _ self at: pos]
						ifFalse:  [c _ nil].
				].
				encodedStream position: 0.
				[(c _ converter nextFromStream: encodedStream) notNil ] whileTrue: [
								ans nextPut: c].
				oldPos _ pos.
			]
			ifFalse: [ans nextPut: c.
					oldPos _ pos + 1
			].
	].
	(oldPos <= self size) ifTrue: [
		ans nextPutAll: (self copyFrom: oldPos to: self size) ].

	^ ans contents! !


!ByteString methodsFor: 'comparing' stamp: 'tak 11/6/2005 23:08'!
findSubstring: key in: body startingAt: start matchTable: matchTable 
	"self assert: ('i' beginsWith: 20999017 asCharacter asString) not"
	"self assert: (((String newFrom: {20999017 asCharacter. 20983887
	asCharacter}) beginsWith: 20999017 asCharacter asString))"
	^ key isByteString
		ifTrue: [self
				primitiveFindSubstring: key
				in: body
				startingAt: start
				matchTable: matchTable]
		ifFalse: [super
				findSubstring: key
				in: body
				startingAt: start
				matchTable: matchTable]! !


!String class methodsFor: 'primitives' stamp: 'yo 12/15/2005 13:41'!
compare: string1 with: string2 collated: order
	"Return 1, 2 or 3, if string1 is <, =, or > string2, with the collating order of characters given by the order array."

	| len1 len2 c1 c2 |
	order == nil ifTrue: [
		len1 _ string1 size.
		len2 _ string2 size.
		1 to: (len1 min: len2) do:[:i |
			c1 _ (string1 at: i) asInteger.
			c2 _ (string2 at: i) asInteger.
			c1 = c2 ifFalse: [c1 < c2 ifTrue: [^ 1] ifFalse: [^ 3]].
		].
		len1 = len2 ifTrue: [^ 2].
		len1 < len2 ifTrue: [^ 1] ifFalse: [^ 3].
	].
	len1 _ string1 size.
	len2 _ string2 size.
	1 to: (len1 min: len2) do:[:i |
		c1 _ (string1 at: i) asInteger.
		c2 _ (string2 at: i) asInteger.
		c1 < 256 ifTrue: [c1 _ order at: c1 + 1].
		c2 < 256 ifTrue: [c2 _ order at: c2 + 1].
		c1 = c2 ifFalse:[c1 < c2 ifTrue: [^ 1] ifFalse: [^ 3]].
	].
	len1 = len2 ifTrue: [^ 2].
	len1 < len2 ifTrue: [^ 1] ifFalse: [^ 3].
! !


!ByteString class methodsFor: 'primitives' stamp: 'yo 12/15/2005 13:44'!
compare: string1 with: string2 collated: order
	"Return 1, 2 or 3, if string1 is <, =, or > string2, with the collating order of characters given by the order array."

	| len1 len2 c1 c2 |
	<primitive: 'primitiveCompareString' module: 'MiscPrimitivePlugin'>
	self var: #string1 declareC: 'unsigned char *string1'.
	self var: #string2 declareC: 'unsigned char *string2'.
	self var: #order declareC: 'unsigned char *order'.

	len1 _ string1 size.
	len2 _ string2 size.
	1 to: (len1 min: len2) do:
		[:i |
		c1 _ order at: (string1 basicAt: i) + 1.
		c2 _ order at: (string2 basicAt: i) + 1.
		c1 = c2 ifFalse: 
			[c1 < c2 ifTrue: [^ 1] ifFalse: [^ 3]]].
	len1 = len2 ifTrue: [^ 2].
	len1 < len2 ifTrue: [^ 1] ifFalse: [^ 3].
! !

Utilities class removeSelector: #makeNihongoImage!
ByteSymbol removeSelector: #compare:with:collated:!
ByteString removeSelector: #compare:with:collated:!
KeyboardInputInterpreter subclass: #MacUnicodeInputInterpreter
	instanceVariableNames: 'keyValueIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-TextConversion'!
