'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 22 March 2006 at 6:57:18 pm'!
"Change Set:		GetTextUTF8-tak
Date:			22 March 2006
Author:			Takashi Yamamiya

Gettext support with UTF-8 for LanguageEditor.
This source code is based on SqueakSmallLand38-0324-1233.image.
"!

Object subclass: #GetTextInterchange
	instanceVariableNames: 'language stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Editor'!
GetTextInterchange subclass: #GetTextExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Editor'!
GetTextInterchange subclass: #GetTextImporter
	instanceVariableNames: 'msgId msgStr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Editor'!

!GetTextInterchange methodsFor: 'private' stamp: 'dgd 9/24/2004 18:50'!
defaultFileName
	^ language displayLanguage , '.po' ! !

!GetTextInterchange methodsFor: 'private' stamp: 'gm 5/2/2004 22:48'!
formatReplacements
	| replacements |
	replacements := OrderedCollection new.
	^ replacements! !

!GetTextInterchange methodsFor: 'private' stamp: 'gm 5/2/2004 22:47'!
formatString: aString 
	| result |
	result := aString.
	self formatReplacements
		do: [:each | result := result copyReplaceAll: each key with: each value].
	^ result! !


!GetTextExporter methodsFor: 'exporting' stamp: 'tak 3/22/2006 17:11'!
export: aLanguage 
	language := aLanguage.
	[stream := FileStream forceNewFileNamed: self defaultFileName.
	stream wantsLineEndConversion: true.
	stream lineEndConvention: #lf.
	stream converter: UTF8TextConverter new.
	self exportHeader.
	self exportTranslations.
	self exportUntranslated]
		ensure: [stream close]! !

!GetTextExporter methodsFor: 'private' stamp: 'dgd 9/24/2004 18:46'!
exportMsgId: aString 
	stream nextPutAll: 'msgid';
		 space;
		 nextPut: $";
		 nextPutAll: (self formatString: aString) ;
		 nextPut: $";
		 cr! !

!GetTextExporter methodsFor: 'private' stamp: 'dgd 9/24/2004 18:46'!
exportMsgStr: aString 
	stream nextPutAll: 'msgstr';
		 space;
		 nextPut: $";
		 nextPutAll: (self formatString: aString) ;
		 nextPut: $";
		 cr! !

!GetTextExporter methodsFor: 'private' stamp: 'gm 5/2/2004 22:48'!
formatReplacements
	| replacements |
	replacements := super formatReplacements.
	replacements add: '\' -> '\\'.
	replacements add: String cr -> '\n'.
	replacements add: String tab -> '\t'.
	replacements add: '"' -> '\"'.
	^ replacements! !

!GetTextExporter methodsFor: 'private-headers' stamp: 'tak 3/22/2006 13:46'!
createHeaders
	| headers |
	headers := OrderedCollection new.
	headers add: 'Project-Id-Version' -> 'Small-Land'.
	headers add: 'POT-Creation-Date' -> self currentDateAndTime.
	headers add: 'PO-Revision-Date' -> self currentDateAndTime.
	headers add: 'Last-Translator' -> ''.
	headers add: 'Language-Team' -> ''.
	headers add: 'MIME-Version' -> '1.0'.
	headers add: 'Content-Type' -> ('text/plain; charset=', stream converter class encodingNames first).
	headers add: 'Content-Transfer-Encoding' -> '8bit'.
	^ headers! !

!GetTextExporter methodsFor: 'private-headers' stamp: 'gm 10/26/2003 12:28'!
currentDateAndTime
	^ String
		streamContents: [:aStream | 
			aStream nextPutAll: Date today yyyymmdd;
				space.
			Time now
				print24: true
				showSeconds: false
				on: aStream.
			aStream nextPutAll: '-0000']! !

!GetTextExporter methodsFor: 'private-headers' stamp: 'gm 10/26/2003 12:13'!
exportHeader
	self exportMsgId: ''.
	self exportMsgStr: ''.
	self createHeaders
		do: [:each | self exportHeaderLineKey: each key value: each value].
	stream cr; cr! !

!GetTextExporter methodsFor: 'private-headers' stamp: 'gm 10/26/2003 12:13'!
exportHeaderLineKey: keyString value: valueString 
	stream nextPut: $";
		 nextPutAll: keyString;
		 nextPut: $:;
		 space;
		 nextPutAll: valueString;
		 nextPutAll: '\n';
		 nextPut: $";
		 cr! !

!GetTextExporter methodsFor: 'private-translations' stamp: 'gm 12/28/2003 16:20'!
exportPhrase: phraseString translation: translationString 
	phraseString isEmpty ifTrue: [^self].
	self exportMsgId: phraseString.
	self exportMsgStr: translationString.
	stream cr! !

!GetTextExporter methodsFor: 'private-translations' stamp: 'tak 3/22/2006 13:39'!
exportTranslations
	| keys |
	keys := language translations keys asArray sort.
	keys
		do: [:key | self
				exportPhrase: key
				translation: (language translations at: key)]! !

!GetTextExporter methodsFor: 'private-translations' stamp: 'dgd 12/30/2003 15:03'!
exportUntranslated
	language untranslated
		do: [:each  | self exportPhrase: each translation: '']! !


!GetTextImporter methodsFor: 'importing' stamp: 'tak 3/22/2006 15:23'!
import: aLanguage 
	| currentPlatform |
	language := aLanguage.
	currentPlatform := Locale currentPlatform.
	[Locale
		currentPlatform: (Locale localeID: aLanguage localeID).
	[stream := FileStream oldFileNamed: self defaultFileName.
	stream text.
	self parse]
		ensure: [stream notNil
				ifTrue: [stream close]]]
		ensure: [Locale currentPlatform: currentPlatform]! !

!GetTextImporter methodsFor: 'private' stamp: 'gm 5/2/2004 22:48'!
formatReplacements
	| replacements |
	replacements := super formatReplacements.
	replacements add: '\\' -> '\'.
	replacements add: '\n' -> String cr.
	replacements add: '\t' -> String tab.
	replacements add: '\"' -> '"'.
	^ replacements! !

!GetTextImporter methodsFor: 'private' stamp: 'dgd 10/3/2004 17:44'!
storeTranslation
	msgId isNil | msgStr isNil
		ifTrue: [^ self].
	msgId isEmpty
		ifTrue: [^ self].
NaturalLanguageTranslator registerPhrase: msgId.
	msgStr isEmpty
		ifTrue: []
		ifFalse: [language
				phrase: msgId
				translation: (self formatString: msgStr)].
	msgId := nil.
	msgStr := nil! !

!GetTextImporter methodsFor: 'parsing' stamp: 'dgd 10/3/2004 17:42'!
parse
	[stream atEnd]
		whileFalse: [| line | 
			line := stream upTo: Character linefeed.
			self parseLine: line].
	! !

!GetTextImporter methodsFor: 'parsing' stamp: 'tak 3/22/2006 14:51'!
parseLine: lineString 
	(lineString beginsWith: '"Content-Type:')
		ifTrue: [self setContentType: lineString.
			^ self].
	(lineString beginsWith: 'msgid')
		ifTrue: [self parseMsgId: lineString.
			^ self].
	(lineString beginsWith: 'msgstr')
		ifTrue: [self parseMsgStr: lineString.
			^ self].
	self storeTranslation! !

!GetTextImporter methodsFor: 'parsing' stamp: 'gm 5/2/2004 22:53'!
parseMsgId: lineString 
	msgId := self parseMsgSection: 'msgid' line: lineString ! !

!GetTextImporter methodsFor: 'parsing' stamp: 'dgd 10/3/2004 17:20'!
parseMsgSection: msgSectionString line: lineString 
	| msgSectionFullLine msgSectionWithQuotes msgSection |
	msgSectionFullLine := lineString withBlanksTrimmed.
	msgSectionWithQuotes := (msgSectionFullLine allButFirst: msgSectionString size) withBlanksTrimmed.
	msgSection := msgSectionWithQuotes allButFirst allButLast.
	^ msgSection! !

!GetTextImporter methodsFor: 'parsing' stamp: 'gm 5/2/2004 23:01'!
parseMsgStr: lineString 
	msgStr := self parseMsgSection: 'msgstr' line: lineString! !

!GetTextImporter methodsFor: 'parsing' stamp: 'tak 3/22/2006 15:10'!
setContentType: lineString 
	"self new setContentType: 'Content-Type: text/plain; charset=utf-8'"
	| reader charSet |
	reader := lineString readStream.
	reader upTo: $=.
	charSet := reader upTo: $\.
	stream
		converter: (TextConverter newForEncoding: charSet)! !


!LanguageEditor methodsFor: 'gui methods' stamp: 'dgd 9/24/2004 19:42'!
getText
	| menu |
	menu := MenuMorph new defaultTarget: self.
	""
	menu
		add: 'gettext export' translated
		target: self
		selector: #getTextExport.
	menu lastItem setBalloonText: 'Exports the translations to GetText format.' translated.
	""
	menu
		add: 'gettext import' translated
		target: self
		selector: #getTextImport.
	menu lastItem setBalloonText: 'Imports the translations from GetText format.' translated.
	""
	menu popUpInWorld! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'dgd 9/24/2004 19:45'!
getTextExport
	Cursor wait
		showWhile: [GetTextExporter new export: self model] ! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'tak 3/22/2006 17:11'!
getTextImport
	self
		withUnboundModelDo: [:mod | ""
			Cursor wait
				showWhile: [GetTextImporter new import: mod]].
	self refreshBoth.! !

!LanguageEditor methodsFor: 'private' stamp: 'dgd 8/13/2004 22:39'!
withUnboundModelDo: aBlock 
	"Private - Evaluate aBlock with the receiver temporary  
	unbound from the model.  
	 
	Useful to perform a batch of modifications to the model  
	without updating the view."
	| formerModel |
	formerModel := self model.
	self model: nil.
	[aBlock value: formerModel]
		ensure: [self model: formerModel]! !

