'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 23 March 2006 at 2:58:45 pm'!
"Change Set:		fixGetTextEscape-tak
Date:			23 March 2006
Author:			Takashi Yamamiya

- fix a bug that \ becomes \\\ through gettext export and import.
- add unit test for basic function in LanguageEditor"!

TestCase subclass: #LanguageEditorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Multilingual-Editor'!

!LanguageEditorTest commentStamp: 'tak 3/23/2006 14:28' prior: 0!
self buildSuite run!


!GetTextInterchange methodsFor: 'accessing' stamp: 'tak 3/23/2006 13:52'!
language: translator
	language _ translator! !

!GetTextInterchange methodsFor: 'accessing' stamp: 'tak 3/23/2006 13:53'!
stream
	^ stream! !

!GetTextInterchange methodsFor: 'accessing' stamp: 'tak 3/23/2006 13:52'!
stream: aStream
	stream _ aStream! !


!GetTextImporter methodsFor: 'private' stamp: 'tak 3/23/2006 14:26'!
storeTranslation
	| key |
	msgId isNil | msgStr isNil
		ifTrue: [^ self].
	msgId isEmpty
		ifTrue: [^ self].
	key := self formatString: msgId.
	NaturalLanguageTranslator registerPhrase: key.
	msgStr isEmpty
		ifFalse: [language
				phrase: key
				translation: (self formatString: msgStr)].
	msgId := nil.
	msgStr := nil! !


!LanguageEditorTest methodsFor: 'testing' stamp: 'tak 3/23/2006 12:58'!
testAddRemove
	"self debug: #testAddRemove"
	| translator |
	translator := self translator.
	translator phrase: 'source' translation: 'translated'.
	self assert: (translator translate: 'source')
			= 'translated'.
	translator removeTranslationFor: 'source'.
	self assert: (translator translate: 'source')
			= 'source'! !

!LanguageEditorTest methodsFor: 'testing' stamp: 'tak 3/23/2006 14:27'!
testGettext
	"self debug: #testGettext"
	| translator |
	translator := self translator.
	translator phrase: 'source' translation: 'translated'.
	translator phrase: 'new
line' translation: 'translated
new
line'.
	GetTextExporter new export: translator.
""
	translator removeTranslationFor: 'source'.
	translator removeTranslationFor: 'new
line'.
""
	GetTextImporter new import: translator.

	self assert: (translator translate: 'source')
			= 'translated'.
	self assert: (translator translate: 'new
line')
			= 'translated
new
line'! !

!LanguageEditorTest methodsFor: 'testing' stamp: 'tak 3/23/2006 14:05'!
testGettextExportFormat
	"self debug: #testGettextExportFormat"
	| exporter |
	exporter := GetTextExporter new.
	exporter stream: '' writeStream.
	exporter exportPhrase: 'source' translation: 'translated'.
	self assert: exporter stream contents = 'msgid "source"
msgstr "translated"

'.
	exporter stream: '' writeStream.
	exporter exportPhrase: '"quoted" phrase' translation: '"QUOTED" PHRASE'.
	self assert: exporter stream contents = 'msgid "\"quoted\" phrase"
msgstr "\"QUOTED\" PHRASE"

'! !

!LanguageEditorTest methodsFor: 'testing' stamp: 'tak 3/23/2006 14:13'!
testGettextImportFormat
	"self debug: #testGettextImportFormat"
	| importer |
	importer := GetTextImporter new.
	importer language: self translator.
	importer parseLine: 'msgid "source"'.
	importer parseLine: 'msgstr "translated"'.
	importer parseLine: ''.
	self assert: (self translator translate: 'source')
			= 'translated'.
	importer parseLine: 'msgid "\"quoted\" phrase"'.
	importer parseLine: 'msgstr "\"QUOTED\" PHRASE"'.
	importer parseLine: ''.
	self assert: (self translator translate: '"quoted" phrase')
			= '"QUOTED" PHRASE'! !

!LanguageEditorTest methodsFor: 'running' stamp: 'tak 3/23/2006 14:28'!
idString
	^ 'testid'! !

!LanguageEditorTest methodsFor: 'running' stamp: 'tak 3/23/2006 14:28'!
tearDown
	NaturalLanguageTranslator
		removeLocaleID: (LocaleID isoString: self idString)! !

!LanguageEditorTest methodsFor: 'running' stamp: 'tak 3/23/2006 14:29'!
translator
	^ NaturalLanguageTranslator
		newLocaleID: (LocaleID isoString: self idString)! !


!LocaleID methodsFor: 'accessing' stamp: 'tak 3/23/2006 12:26'!
displayLanguage
	| language |
	language := (ISOLanguageDefinition iso2LanguageTable
				at: self isoLanguage
				ifAbsent: [^ self isoLanguage]) language.
	^ self isoCountry
		ifNil: [language]
		ifNotNil: [language , ' (' , self displayCountry , ')']! !


!LanguageEditorTest reorganize!
('testing' testAddRemove testGettext testGettextExportFormat testGettextImportFormat)
('running' idString tearDown translator)
!


!GetTextInterchange reorganize!
('private' defaultFileName formatReplacements formatString:)
('accessing' language: stream stream:)
!

